###############################################################
###   Tcl Variables
###############################################################
#set tclParams [list <param1> <value> <param2> <value> ... <paramN> <value>]
set tclParams [list place.closeImportedSites  1 \
                    hd.StrictContainRouting   1 \
              ]
#                    general.maxThreads 8 \              

#Define location for "Tcl" directory. Defaults to "./Tcl"
set tclHome 
if {[file exists $tclHome]} {
   set tclDir $tclHome
} elseif {[file exists "./Tcl"]} {
   set tclDir  "./Tcl"
} else {
   error "ERROR: No valid location found for required Tcl scripts. Set \$tclDir in design.tcl to a valid location."
}

###############################################################
### Define Part, Package, Speedgrade 
###############################################################
#set device       "devicePN"
#set package      "devicePKG"
#set speed        "deviceSPEED"
#set part         $device$package$speed
set part         "device"

###############################################################
###  Setup Variables
###############################################################
####flow control
set run.topSynth   0
set run.tdImpl     1

####Report and DCP controls - values: 0-required min; 1-few extra; 2-all
set verbose      1
set dcpLevel     1

####Output Directories
set synthDir  "./synthDir"
set implDir   "./implDir"
set dcpDir    "./dcpDir"

####Input Directories
set srcDir     "./"
set rtlDir     "$srcDir/src_rtl"
set prjDir     "$srcDir"
set xdcDir     "$srcDir"

####Source required Tcl Procs
source $tclDir/design_utils.tcl
source $tclDir/synth_utils.tcl
source $tclDir/impl_utils.tcl
source $tclDir/hd_floorplan_utils.tcl

###############################################################
### Top Definition
###############################################################
set top "uut_top"
add_module $top
set_attribute module $top    top_level     1
set_attribute module $top    prj           $prjDir/temp.prj
set_attribute module $top    synth         ${run.topSynth}
set_attribute module $top synthXDC [list $xdcDir/${top}_flpn.xdc]
set_attribute module $top synth_options "-max_bram 0"
set_property SEVERITY {Warning} [get_drc_checks NSTD-1]
set_property SEVERITY {Warning} [get_drc_checks UCIO-1]
####################################################################
### Create TopDown implementation run 
####################################################################
#stratDef
add_implementation TopDown1
set_attribute impl TopDown1      top          $top
set_attribute impl TopDown1      implXDC      [list $xdcDir/${top}_flpn.xdc] 
set_attribute impl TopDown1      td.impl      0
set_attribute impl TopDown1      impl         ${run.tdImpl}
set_attribute impl TopDown1      phys         0
#stratDef

# Build the designs
source $tclDir/run.tcl

exit
