""" Xilinx Vivado optimization settings. """

class vivadoConfig(object):

    @staticmethod
    def getStratString(f_idx, o_idx):
        returnStr = ""

        if (o_idx == 1):
            returnStr = "add_implementation TopDown1\n" + \
                        "set_attribute impl TopDown1      top          $top\n" + \
                        "set_attribute impl TopDown1      implXDC      [list $xdcDir/freq" + str(f_idx) + ".xdc]\n" + \
                        "set_attribute impl TopDown1      td.impl      0\n" + \
                        "set_attribute impl TopDown1      impl         ${run.tdImpl}\n" + \
                        "set_attribute impl TopDown1      phys         0\n"

        elif (o_idx == 2):
            returnStr = "add_implementation TopDown2\n" + \
                        "set_attribute impl TopDown2      top          $top\n" + \
                        "set_attribute impl TopDown2      implXDC      [list $xdcDir/freq" + str(f_idx) + ".xdc]\n" + \
                        "set_attribute impl TopDown2      td.impl      0\n" + \
                        "set_attribute impl TopDown2      impl         ${run.tdImpl}\n" + \
                        "set_attribute impl TopDown2   opt_directive         Explore\n" + \
                        "set_attribute impl TopDown2   place_directive       Explore\n" + \
                        "set_attribute impl TopDown2   phys_directive        Explore\n" + \
                        "set_attribute impl TopDown2   route_directive       Explore\n"

        elif (o_idx == 3):
            returnStr = "add_implementation TopDown3\n" + \
                        "set_attribute impl TopDown3      top          $top\n" + \
                        "set_attribute impl TopDown3      implXDC      [list $xdcDir/freq" + str(f_idx) + ".xdc]\n" + \
                        "set_attribute impl TopDown3      td.impl      0\n" + \
                        "set_attribute impl TopDown3      impl         ${run.tdImpl}\n" + \
                        "set_attribute impl TopDown3   place_directive       WLDrivenBlockPlacement\n" + \
                        "set_attribute impl TopDown3   phys_directive        AggressiveExplore\n" + \
                        "set_attribute impl TopDown3   route_directive       MoreGlobalIterations\n"

        elif (o_idx == 4):
            returnStr = "add_implementation TopDown4\n" + \
                        "set_attribute impl TopDown4      top          $top\n" + \
                        "set_attribute impl TopDown4      implXDC      [list $xdcDir/freq" + str(f_idx) + ".xdc]\n" + \
                        "set_attribute impl TopDown4      td.impl      0\n" + \
                        "set_attribute impl TopDown4      impl         ${run.tdImpl}\n" + \
                        "set_attribute impl TopDown4   place_directive       ExtraPostPlacementOpt\n" + \
                        "set_attribute impl TopDown4   route_directive       NoTimingRelaxation\n"

        elif (o_idx == 5):
            returnStr = "add_implementation TopDown5\n" + \
                        "set_attribute impl TopDown5      top          $top\n" + \
                        "set_attribute impl TopDown5      implXDC      [list $xdcDir/freq" + str(f_idx) + ".xdc]\n" + \
                        "set_attribute impl TopDown5      td.impl      0\n" + \
                        "set_attribute impl TopDown5      impl         ${run.tdImpl}\n" + \
                        "set_attribute impl TopDown5   place_directive       WLDrivenBlockPlacement\n" + \
                        "set_attribute impl TopDown5   phys_directive        AlternateReplication\n" + \
                        "set_attribute impl TopDown5   route_directive       HigherDelayCost\n"

        elif (o_idx == 6):
            returnStr = "add_implementation TopDown6\n" + \
                        "set_attribute impl TopDown6      top          $top\n" + \
                        "set_attribute impl TopDown6      implXDC      [list $xdcDir/freq" + str(f_idx) + ".xdc]\n" + \
                        "set_attribute impl TopDown6      td.impl      0\n" + \
                        "set_attribute impl TopDown6      impl         ${run.tdImpl}\n" + \
                        "set_attribute impl TopDown6   place_directive       LateBlockPlacement\n" + \
                        "set_attribute impl TopDown6   phys_directive        AggressiveExplore\n" + \
                        "set_attribute impl TopDown6   route_directive       HigherDelayCost\n"

        elif (o_idx == 7):
            returnStr = "add_implementation TopDown7\n" + \
                        "set_attribute impl TopDown7      top          $top\n" + \
                        "set_attribute impl TopDown7      implXDC      [list $xdcDir/freq" + str(f_idx) + ".xdc]\n" + \
                        "set_attribute impl TopDown7      td.impl      0\n" + \
                        "set_attribute impl TopDown7      impl         ${run.tdImpl}\n" + \
                        "set_attribute impl TopDown7   place_directive       ExtraNetDelay_high\n" + \
                        "set_attribute impl TopDown7   route_directive       AdvancedSkewModeling\n"

        elif (o_idx == 8):
            returnStr = "add_implementation TopDown8\n" + \
                        "set_attribute impl TopDown8      top          $top\n" + \
                        "set_attribute impl TopDown8      implXDC      [list $xdcDir/freq" + str(f_idx) + ".xdc]\n" + \
                        "set_attribute impl TopDown8      td.impl      0\n" + \
                        "set_attribute impl TopDown8      impl         ${run.tdImpl}\n" + \
                        "set_attribute impl TopDown8   place_directive       ExtraNetDelay_medium\n" + \
                        "set_attribute impl TopDown8   route_directive       AdvancedSkewModeling\n"

        elif (o_idx == 9):
            returnStr = "add_implementation TopDown9\n" + \
                        "set_attribute impl TopDown9      top          $top\n" + \
                        "set_attribute impl TopDown9      implXDC      [list $xdcDir/freq" + str(f_idx) + ".xdc]\n" + \
                        "set_attribute impl TopDown9      td.impl      0\n" + \
                        "set_attribute impl TopDown9      impl         ${run.tdImpl}\n" + \
                        "set_attribute impl TopDown9   place_directive       ExtraNetDelay_low\n" + \
                        "set_attribute impl TopDown9   route_directive       AdvancedSkewModeling\n"

        elif (o_idx == 10):
            returnStr = "add_implementation TopDown10\n" + \
                        "set_attribute impl TopDown10      top          $top\n" + \
                        "set_attribute impl TopDown10      implXDC      [list $xdcDir/freq" + str(f_idx) + ".xdc]\n" + \
                        "set_attribute impl TopDown10      td.impl      0\n" + \
                        "set_attribute impl TopDown10      impl         ${run.tdImpl}\n" + \
                        "set_attribute impl TopDown10   place_directive       SSI_ExtraTimingOpt\n" + \
                        "set_attribute impl TopDown10   route_directive       NoTimingRelaxation\n"

        elif (o_idx == 11):
            returnStr = "add_implementation TopDown11\n" + \
                        "set_attribute impl TopDown11      top          $top\n" + \
                        "set_attribute impl TopDown11      implXDC      [list $xdcDir/freq" + str(f_idx) + ".xdc]\n" + \
                        "set_attribute impl TopDown11      td.impl      0\n" + \
                        "set_attribute impl TopDown11      impl         ${run.tdImpl}\n" + \
                        "set_attribute impl TopDown11   opt_directive       ExploreArea\n" + \
                        "set_attribute impl TopDown11   phys          0\n"

        elif (o_idx == 12):
            returnStr = "add_implementation TopDown12\n" + \
                        "set_attribute impl TopDown12      top          $top\n" + \
                        "set_attribute impl TopDown12      implXDC      [list $xdcDir/freq" + str(f_idx) + ".xdc]\n" + \
                        "set_attribute impl TopDown12      td.impl      0\n" + \
                        "set_attribute impl TopDown12      impl         ${run.tdImpl}\n" + \
                        "set_attribute impl TopDown12   place_directive       ExtraPostPlacementOpt\n" + \
                        "set_attribute impl TopDown12   phys_directive        AddRetime\n" + \
                        "set_attribute impl TopDown12   route_directive       HigherDelayCost\n"

        elif (o_idx == 13):
            returnStr = "add_implementation TopDown13\n" + \
                        "set_attribute impl TopDown13      top          $top\n" + \
                        "set_attribute impl TopDown13      implXDC      [list $xdcDir/freq" + str(f_idx) + ".xdc]\n" + \
                        "set_attribute impl TopDown13      td.impl      0\n" + \
                        "set_attribute impl TopDown13      impl         ${run.tdImpl}\n" + \
                        "set_attribute impl TopDown13   phys_directive        Explore\n"

        elif (o_idx == 14):
            returnStr = "add_implementation TopDown14\n" + \
                        "set_attribute impl TopDown14      top          $top\n" + \
                        "set_attribute impl TopDown14      implXDC      [list $xdcDir/freq" + str(f_idx) + ".xdc]\n" + \
                        "set_attribute impl TopDown14      td.impl      0\n" + \
                        "set_attribute impl TopDown14      impl         ${run.tdImpl}\n" + \
                        "set_attribute impl TopDown14   phys_directive        Explore\n" + \
                        "set_attribute impl TopDown14   route_options        -tns_cleanup\n"

        elif (o_idx == 15):
            returnStr = "add_implementation TopDown15\n" + \
                        "set_attribute impl TopDown15      top          $top\n" + \
                        "set_attribute impl TopDown15      implXDC      [list $xdcDir/freq" + str(f_idx) + ".xdc]\n" + \
                        "set_attribute impl TopDown15      td.impl      0\n" + \
                        "set_attribute impl TopDown15      impl         ${run.tdImpl}\n" + \
                        "set_attribute impl TopDown15   opt_directive       RuntimeOptimized\n" + \
                        "set_attribute impl TopDown15   place_directive     RuntimeOptimized\n" + \
                        "set_attribute impl TopDown15   route_directive     RuntimeOptimized\n" + \
                        "set_attribute impl TopDown15   phys       0\n"

        elif (o_idx == 16):
            returnStr = "add_implementation TopDown16\n" + \
                        "set_attribute impl TopDown16      top          $top\n" + \
                        "set_attribute impl TopDown16      implXDC      [list $xdcDir/freq" + str(f_idx) + ".xdc]\n" + \
                        "set_attribute impl TopDown16      td.impl      0\n" + \
                        "set_attribute impl TopDown16      impl         ${run.tdImpl}\n" + \
                        "set_attribute impl TopDown16   opt_directive       RuntimeOptimized\n" + \
                        "set_attribute impl TopDown16   place_directive     Quick\n" + \
                        "set_attribute impl TopDown16   route_directive     Quick\n" + \
                        "set_attribute impl TopDown16   phys       0\n"

        elif (o_idx == 17):
            returnStr = "add_implementation TopDown17\n" + \
                        "set_attribute impl TopDown17      top          $top\n" + \
                        "set_attribute impl TopDown17      implXDC      [list $xdcDir/freq" + str(f_idx) + ".xdc]\n" + \
                        "set_attribute impl TopDown17      td.impl      0\n" + \
                        "set_attribute impl TopDown17      impl         ${run.tdImpl}\n" + \
                        "set_attribute impl TopDown17   place_directive     SpreadLogic_high\n" + \
                        "set_attribute impl TopDown17   phys_directive       AlternateReplication\n" + \
                        "set_attribute impl TopDown17   route_directive     MoreGlobalIterations\n"

        elif (o_idx == 18):
            returnStr = "add_implementation TopDown18\n" + \
                        "set_attribute impl TopDown18      top          $top\n" + \
                        "set_attribute impl TopDown18      implXDC      [list $xdcDir/freq" + str(f_idx) + ".xdc]\n" + \
                        "set_attribute impl TopDown18      td.impl      0\n" + \
                        "set_attribute impl TopDown18      impl         ${run.tdImpl}\n" + \
                        "set_attribute impl TopDown18   place_directive     SpreadLogic_medium\n" + \
                        "set_attribute impl TopDown18   phys_directive       AlternateReplication\n" + \
                        "set_attribute impl TopDown18   route_directive     NoTimingRelaxation\n"

        elif (o_idx == 19):
            returnStr = "add_implementation TopDown19\n" + \
                        "set_attribute impl TopDown19      top          $top\n" + \
                        "set_attribute impl TopDown19      implXDC      [list $xdcDir/freq" + str(f_idx) + ".xdc]\n" + \
                        "set_attribute impl TopDown19      td.impl      0\n" + \
                        "set_attribute impl TopDown19      impl         ${run.tdImpl}\n" + \
                        "set_attribute impl TopDown19   place_directive     SpreadLogic_low\n" + \
                        "set_attribute impl TopDown19   route_directive     HigherDelayCost\n"

        elif (o_idx == 20):
            returnStr = "add_implementation TopDown20\n" + \
                        "set_attribute impl TopDown20      top          $top\n" + \
                        "set_attribute impl TopDown20      implXDC      [list $xdcDir/freq" + str(f_idx) + ".xdc]\n" + \
                        "set_attribute impl TopDown20      td.impl      0\n" + \
                        "set_attribute impl TopDown20      impl         ${run.tdImpl}\n" + \
                        "set_attribute impl TopDown20   place_directive     SSI_SpreadSLLs\n" + \
                        "set_attribute impl TopDown20   route_directive     NoTimingRelaxation\n"

        elif (o_idx == 21):
            returnStr = "add_implementation TopDown21\n" + \
                        "set_attribute impl TopDown21      top          $top\n" + \
                        "set_attribute impl TopDown21      implXDC      [list $xdcDir/freq" + str(f_idx) + ".xdc]\n" + \
                        "set_attribute impl TopDown21      td.impl      0\n" + \
                        "set_attribute impl TopDown21      impl         ${run.tdImpl}\n" + \
                        "set_attribute impl TopDown21   place_directive     SSI_BalanceSLLs\n" + \
                        "set_attribute impl TopDown21   route_directive     NoTimingRelaxation\n"

        elif (o_idx == 22):
            returnStr = "add_implementation TopDown22\n" + \
                        "set_attribute impl TopDown22      top          $top\n" + \
                        "set_attribute impl TopDown22      implXDC      [list $xdcDir/freq" + str(f_idx) + ".xdc]\n" + \
                        "set_attribute impl TopDown22      td.impl      0\n" + \
                        "set_attribute impl TopDown22      impl         ${run.tdImpl}\n" + \
                        "set_attribute impl TopDown22   place_directive     SSI_BalanceSLRs\n"

        elif (o_idx == 23):
            returnStr = "add_implementation TopDown23\n" + \
                        "set_attribute impl TopDown23      top          $top\n" + \
                        "set_attribute impl TopDown23      implXDC      [list $xdcDir/freq" + str(f_idx) + ".xdc]\n" + \
                        "set_attribute impl TopDown23      td.impl      0\n" + \
                        "set_attribute impl TopDown23      impl         ${run.tdImpl}\n" + \
                        "set_attribute impl TopDown23   place_directive     SSI_HighUtilSLRs\n"
        else:
            print "Error writing o_idx, index: " + str(o_idx)

        return returnStr

    def getStratStringProjMode(self, o_idx):

        returnStr = ""

        if (o_idx == 1):
            returnStr = "Vivado Implementation Defaults"

        elif (o_idx == 2):
            returnStr = "Performance_Explore"

        elif (o_idx == 3):
            returnStr = "Performance_ExplorePostRoutePhysOpt"

        elif (o_idx == 4):
            returnStr = "Performance_RefinePlacement"

        elif (o_idx == 5):
            returnStr = "Performance_WLBlockPlacement"

        elif (o_idx == 6):
            returnStr = "Performance_WLBlockPlacementFanoutOpt"

        elif (o_idx == 7):
            returnStr = "Performance_NetDelay_high"

        elif (o_idx == 8):
            returnStr = "Performance_NetDelay_medium"

        elif (o_idx == 9):
            returnStr = "Performance_NetDelay_low"

        elif (o_idx == 10):
            returnStr = "Performance_ExploreSLLs"

        elif (o_idx == 11):
            returnStr = "Performance_Retiming"

        elif (o_idx == 12):
            returnStr = "Area_Explore"

        elif (o_idx == 13):
            returnStr = "Power_DefaultOpt"

        elif (o_idx == 14):
            returnStr = "Flow_RunPhysOpt"

        elif (o_idx == 15):
            returnStr = "Flow_RunPostRoutePhysOpt"

        elif (o_idx == 16):
            returnStr = "Flow_RuntimeOptimized"

        elif (o_idx == 17):
            returnStr = "Flow_Quick"

        elif (o_idx == 18):
            returnStr = "Congestion_SpreadLogic_high"

        elif (o_idx == 19):
            returnStr = "Congestion_SpreadLogic_medium"

        elif (o_idx == 20):
            returnStr = "Congestion_SpreadLogic_low"

        elif (o_idx == 21):
            returnStr = "Congestion_SpreadLogicSLLs"

        elif (o_idx == 22):
            returnStr = "Congestion_BalanceSLLs"

        elif (o_idx == 23):
            returnStr = "Congestion_BalanceSLRs"

        elif (o_idx == 24):
            returnStr = "Congestion_CompressSLRs"

        else:
            print "Error writing o_idx, index: " + str(o_idx)

        return returnStr
